if (!defined &_SYS_FS_CACHEFS_FS_H) {
    eval 'sub _SYS_FS_CACHEFS_FS_H {1;}';
    require 'sys/vnode.ph';
    require 'sys/vfs.ph';
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/thread.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub DEF_FILEGRP_SIZE {256;}';
    eval 'sub DEF_POP_SIZE {0x10000;}';
    eval 'sub CFSVERSION {3;}';
    eval 'sub CACHELABEL_NAME {".cfs_label";}';
    eval 'sub RESOURCE_NAME {".cfs_resource";}';
    eval 'sub OPTION_NAME {".cfs_option";}';
    eval 'sub ATTRCACHE_NAME {".cfs_attrcache";}';
    eval 'sub BACKMNT_NAME {".cfs_mnt_points";}';
    eval 'sub CACHEFS_LOCK_FILE {".cfs_lock";}';
    eval 'sub LOG_STATUS_NAME {".cfs_logging";}';
    eval 'sub NOBACKUP_NAME {".nsr";}';
    eval 'sub ROOTLINK_NAME {"root";}';
    eval 'sub CFS_FRONTFILE_NAME_SIZE {9;}';
    eval 'sub CACHEFS_BASETYPE {"cachefs";}';
    require 'sys/fs/cachefs_fscache.ph';
    require 'sys/fs/cachefs_filegrp.ph';
    eval 'sub CUSAGE_ACTIVE {1;}';
    eval 'sub CUSAGE_NEED_ADJUST {2;}';
    eval 'sub CACHE_NOCACHE {0x1;}';
    eval 'sub CACHE_ALLOC_PENDING {0x4;}';
    eval 'sub CACHE_NOFILL {0x8;}';
    eval 'sub CACHE_GARBAGE_COLLECT {0x10;}';
    eval 'sub CACHE_GARBAGE_THREADRUN {0x20;}';
    eval 'sub CACHE_GARBAGE_THREADEXIT {0x40;}';
    eval 'sub CACHE_DIRTY {0x80;}';
    eval 'sub CFS_WRITE_AROUND {0x01;}';
    eval 'sub CFS_DUAL_WRITE {0x02;}';
    eval 'sub CFS_NOCONST_MODE {0x08;}';
    eval 'sub CFS_ACCESS_BACKFS {0x10;}';
    eval 'sub CFS_PURGE {0x20;}';
    eval 'sub CFS_AUTOPURGE {0x40;}';
    eval 'sub CFS_CODCONST_MODE {0x80;}';
    eval 'sub MAXTOKEN_SIZE {32;}';
    eval 'sub MAXCOOKIE_SIZE {36;}';
    eval 'sub C_VERIFY_ATTRS {0x1;}';
    eval 'sub C_BACK_CHECK {0x2;}';
    eval 'sub C_MAX_ALLOCINFO_SLOTS {32;}';
    eval 'sub C_FSL_SIZE {($sizeof{\'struct cachefs_allocmap\'} *  &C_MAX_ALLOCINFO_SLOTS);}';
    eval 'sub MD_POPULATED {0x2;}';
    eval 'sub MD_FILE {0x4;}';
    eval 'sub MD_FASTSYMLNK {0x8;}';
    eval 'sub MD_PINNED {0x10;}';
    eval 'sub MD_INVALREADDIR {0x40;}';
    eval 'sub C_MAX_MOUNT_FSCDIRNAME {128;}';
    eval 'sub MAXCNODES {100;}';
    eval 'sub C_FRONT {0x1;}';
    eval 'sub C_BACK {0x2;}';
    eval 'sub c_attr { &c_metadata. &md_vattr;}';
    eval 'sub c_token { &c_metadata. &md_token;}';
    eval 'sub c_cookie { &c_metadata. &md_cookie;}';
    eval 'sub CFS_DIRCACHE_COST {3;}';
    eval 'sub CFS_DIRCACHE_INVAL {3;}';
    eval 'sub CFS_DIRCACHE_ENABLE {( &CFS_DIRCACHE_INVAL *  &CFS_DIRCACHE_COST);}';
    eval 'sub VTOC {
        local($VP) = @_;
        eval "((( &void *)(($VP)-> &v_data)))";
    }';
    eval 'sub CTOV {
        local($CP) = @_;
        eval "(( &vnode_t *)(( &void *)(&(($CP)-> &c_vnode))))";
    }';
    eval 'sub VFS_TO_FSCACHE {
        local($VFSP) = @_;
        eval "((( &void *)(($VFSP)-> &vfs_data)))";
    }';
    eval 'sub C_TO_FSCACHE {
        local($CP) = @_;
        eval "( &VFS_TO_FSCACHE( &CTOV($CP)-> &v_vfsp))";
    }';
    eval 'sub CN_NOCACHE {0x1;}';
    eval 'sub CN_DESTROY {0x2;}';
    eval 'sub CN_ROOT {0x4;}';
    eval 'sub CN_INACTIVE {0x8;}';
    eval 'sub CN_UPDATED {0x40;}';
    eval 'sub CDIRTY {0x80;}';
    eval 'sub CN_NEED_FRONT_SYNC {0x100;}';
    eval 'sub CN_ALLOC_PENDING {0x200;}';
    eval 'sub CN_STALE {0x400;}';
    eval 'sub CFASTSYMLNK {0x800;}';
    eval 'sub CN_MODIFIED {0x1000;}';
    eval 'sub CN_NEED_INVAL {0x2000;}';
    eval 'sub CN_HASHSKIP {0x4000;}';
    eval 'sub CN_POPULATION_PENDING {0x8000;}';
    eval 'sub CN_LRU {0x10000;}';
    eval 'sub CIO_PUTPAGES {0x1;}';
    eval 'sub CHASH {
        local($FILENO) = @_;
        eval "(($FILENO & ( &CNODE_BUCKET_SIZE - 1)))";
    }';
    eval 'sub CFS_MAX_THREADS {5;}';
    eval 'sub CFS_ASYNC_TIMEOUT {(60 *  &HZ);}';
    eval 'sub CFS_MAX_EXPORT_SIZE {10;}';
    eval 'sub CFS_FID_LOCAL {1;}';
    eval 'sub CFS_FID_BACK {2;}';
    eval 'sub CFS_FID_SIZE {($sizeof{\'struct cachefs_fid\'} - $sizeof{\'u_short\'});}';
    eval 'sub CFS_CM_FRONT {1;}';
    eval 'sub CFS_CM_BACK {2;}';
    eval 'sub CFS_BOI_ROOTFS {1;}';
    eval 'sub CFS_BOI_FRONTFS {2;}';
    eval 'sub CFS_BOI_BACKFS {3;}';
    eval 'sub CACHEFS_DEBUG_DEPTH {(16);}';
    if (defined( &_KERNEL) && defined( &__STDC__)) {
    }
    eval 'sub C_LRU_MAXENTS {0x4000;}';
    if (defined &DEBUG) {
	eval 'sub CFSDEBUG_ALL {0xffffffff;}';
	eval 'sub CFSDEBUG_NONE {0x0;}';
	eval 'sub CFSDEBUG_GENERAL {0x1;}';
	eval 'sub CFSDEBUG_SUBR {0x2;}';
	eval 'sub CFSDEBUG_CNODE {0x4;}';
	eval 'sub CFSDEBUG_DIR {0x8;}';
	eval 'sub CFSDEBUG_STRICT {0x10;}';
	eval 'sub CFSDEBUG_VOPS {0x20;}';
	eval 'sub CFSDEBUG_VFSOP {0x40;}';
	eval 'sub CFSDEBUG_RESOURCE {0x80;}';
	eval 'sub CFSDEBUG_CHEAT {0x100;}';
	eval 'sub CFS_DEBUG {
	    local($N) = @_;
	    eval " &if ( &cachefsdebug & ($N))";
	}';
	eval 'sub CFSDEBUG {1;}';
    }
    eval 'sub C_ISVDEV {
        local($t) = @_;
        eval "(($t ==  &VBLK) || ($t ==  &VCHR) || ($t ==  &VFIFO))";
    }';
    require 'sys/ioccom.ph';
    eval 'sub _FIOPIN { &_IO(ord(\'f\'), 72);}';
    eval 'sub _FIOUNPIN { &_IO(ord(\'f\'), 73);}';
    eval 'sub _FIOCOD { &_IO(ord(\'f\'), 78);}';
    eval 'sub _FIOBOINFO { &_IO(ord(\'f\'), 79);}';
    eval 'sub _FIOCNVTMNT { &_IO(ord(\'f\'), 80);}';
    if (defined &__cplusplus) {
    }
}
1;
